/**
 * Functions for the image listing, used by images.php only
 * @author $Author: Alfmiti $
 * @version $Id: images.js,v 1.1.1.1 2004/08/20 20:03:58 Alfmiti Exp $
 * @package ImageManager
 */

	function i18n(str) {
		if(I18N && typeof I18N[str] == 'string')
		  return I18N[str];
		else
			return str;
	};

	function changeDir(newDir, mode)
	{
		showMessage('Loading');
		location.href = mode + ".php?dir="+newDir;
	}


	function newFolder(dir, newDir)
	{
		location.href = "images.php?dir="+dir+"&newDir="+newDir;
	}

	//update the dir list in the parent window.
	function updateDir(newDir)
	{
		var selection = window.top.document.getElementById('dirPath');
		if(selection)
		{
			for(var i = 0; i < selection.length; i++)
			{
				var thisDir = selection.options[i].text;
				if(thisDir == newDir)
				{
					selection.selectedIndex = i;
					showMessage('Loading');
					break;
				}
			}
		}
	}

	function selectImage(mediaUrl, mediaFilename, width, height)
	{
		var topDoc = window.top.document;
		var pfx = parent.mediaMode == 'link' ? 'link_' : '';
  		topDoc.getElementById('f_' + pfx + 'file').value = mediaFilename;
  		topDoc.getElementById('f_' + pfx + 'url').value = mediaUrl;
  		topDoc.getElementById('f_' + pfx + 'width').value = width;
  		topDoc.getElementById('f_' + pfx + 'height').value = height;
  		topDoc.getElementById('f_' + pfx + 'alt').value = mediaFilename;
  		topDoc.getElementById('orginal_' + pfx + 'width').value = width;
  		topDoc.getElementById('orginal_' + pfx + 'height').value = height;
	}

	function showMessage(newMessage)
	{
		var topDoc = window.top.document;

		var message = topDoc.getElementById('message');
		var messages = topDoc.getElementById('messages');
		if(message && messages)
		{
			if(message.firstChild)
				message.removeChild(message.firstChild);

			message.appendChild(topDoc.createTextNode(i18n(newMessage)));

			messages.style.display = "block";
		}
	}

	function addEvent(obj, evType, fn)
	{
		if (obj.addEventListener) { obj.addEventListener(evType, fn, true); return true; }
		else if (obj.attachEvent) {  var r = obj.attachEvent("on"+evType, fn);  return r;  }
		else {  return false; }
	}

	function confirmDeleteFile(file)
	{
		if(confirm(i18n("Delete file?")))
			return true;

		return false;
	}

	function confirmDeleteDir(dir, count)
	{
		if(count > 0) {
			alert(i18n("Please delete all files/folders inside the folder you wish to delete first."));
			return false;
		}

		if(confirm(i18n("Delete folder?")))
			return true;

		return false;
	}

   function editImage(image)
	{
		var url = "editor.php?img="+image;
		Dialog(url, function(param)
		{
			if (!param) // user must have pressed Cancel
				return false;
			else
			{
				return true;
			}
		}, null);
	}

	function previewMedia(media_url,width,height) {
      var properties = 'status=no,toolbar=no,scrollbars=no,resizable=yes,';
      if (width != 'undefinend') properties += 'width='+width+',height='+height;
      window.open(media_url,'Mediapopup',properties);
	}


	addEvent(window, 'load', init);